<template>
  <div class="xxx-container auto-height-container" :class="{ 'fullscreen-container': isFullscreen }">
    <vab-query-form>
      <vab-query-form-top-panel>
        <el-form ref="queryRef" inline label-width="70px" :model="queryForm" @submit.prevent>
          <el-form-item label="登录地址" prop="ipaddr">
            <el-input v-model="queryForm.ipaddr" clearable placeholder="请输入登录地址" style="width: 240px" @keyup.enter="handleQuery" />
          </el-form-item>
          <el-form-item v-show="!fold" label="用户名称" prop="userName">
            <el-input v-model="queryForm.userName" clearable placeholder="请输入用户名称" style="width: 240px" @keyup.enter="handleQuery" />
          </el-form-item>
          <el-form-item v-show="!fold" label="状态" prop="status">
            <el-select v-model="queryForm.status" clearable placeholder="登录状态" style="width: 240px">
              <el-option v-for="dict in sys_common_status" :key="dict.value" :label="dict.label" :value="dict.value" />
            </el-select>
          </el-form-item>
          <el-form-item v-show="!fold" label="登录时间" prop="dateRange" style="width: 308px">
            <el-date-picker
              v-model="queryForm.dateRange"
              :default-time="[new Date(2000, 1, 1, 0, 0, 0), new Date(2000, 1, 1, 23, 59, 59)]"
              end-placeholder="结束日期"
              range-separator="-"
              start-placeholder="开始日期"
              type="daterange"
              value-format="YYYY-MM-DD HH:mm:ss"
            />
          </el-form-item>
          <el-form-item>
            <el-button icon="Search" :loading="listLoading" native-type="submit" type="primary" @click="handleQuery">查询</el-button>
            <el-button icon="Refresh" @click="resetQuery">重置</el-button>
            <el-button class="hidden-xs-only" text type="primary" @click="handleFold">
              <span v-if="fold">展开</span>
              <span v-else>合并</span>
              <vab-icon class="vab-dropdown" :class="{ 'vab-dropdown-active': fold }" icon="arrow-up-s-line" />
            </el-button>
          </el-form-item>
        </el-form>
      </vab-query-form-top-panel>
      <vab-query-form-left-panel>
        <el-button icon="Delete" type="danger" @click="handleDelete">删除</el-button>
        <el-button icon="Delete" type="danger" @click="handleClean">清空</el-button>
        <el-button :disabled="selectRows.length !== 1" icon="Unlock" plain type="primary" @click="handleUnlock">解锁</el-button>
        <el-button icon="Upload" plain type="warning" @click="handleExport">导出</el-button>
      </vab-query-form-left-panel>
      <vab-query-form-right-panel>
        <div class="custom-table-right-tools">
          <el-button @click="handleQuery">
            <vab-icon icon="refresh-line" />
          </el-button>
          <el-button @click="clickFullScreen">
            <vab-icon :icon="isFullscreen ? 'fullscreen-exit-fill' : 'fullscreen-fill'" />
          </el-button>
          <el-popover popper-class="custom-table-checkbox">
            <template #reference>
              <el-button>
                <vab-icon icon="settings-line" />
              </el-button>
            </template>
            <vab-draggable v-model="columns" :animation="600" target=".el-checkbox-group">
              <el-checkbox-group v-model="checkList">
                <el-checkbox
                  v-for="item in columns"
                  :key="item.label"
                  :disabled="item.disableCheck"
                  :label="item.label"
                  :value="item.label"
                >
                  {{ item.label }}
                </el-checkbox>
              </el-checkbox-group>
            </vab-draggable>
          </el-popover>
        </div>
      </vab-query-form-right-panel>
    </vab-query-form>

    <el-table
      ref="tableRef"
      v-loading="listLoading"
      border
      :data="list"
      :default-sort="defaultSort"
      @selection-change="setSelectRows"
      @sort-change="handleSortChange"
    >
      <el-table-column align="center" type="selection" width="50" />

      <el-table-column
        v-for="(item, index) in finallyColumns"
        :key="index"
        align="center"
        :fixed="item.fixed"
        :label="item.label"
        :min-width="item.minWidth || 160"
        :prop="item.prop"
        show-overflow-tooltip
        :sortable="item.sortable"
      >
        <template #default="scope">
          <span v-if="item.label === '登录状态'">
            <dict-tag :options="sys_common_status" :value="scope.row.status" />
          </span>
          <span v-else>{{ scope.row[item.prop] }}</span>
        </template>
      </el-table-column>
      <template #empty>
        <el-empty class="vab-data-empty" description="暂无数据" />
      </template>
    </el-table>
    <vab-pagination
      :current-page="queryForm.pageNum"
      :page-size="queryForm.pageSize"
      :total="total"
      @current-change="handleCurrentChange"
      @size-change="handleSizeChange"
    />
  </div>
</template>

<script lang="ts" setup>
import type { TableInstance } from 'element-plus'
import { VueDraggable as VabDraggable } from 'vue-draggable-plus'
import { cleanLogininfor, doDelete, getList, unlockLogininfor } from '/@/api/loginLog'

defineOptions({
  name: 'LoginLog',
})

const { proxy } = getCurrentInstance() as any
const { sys_common_status } = proxy.useDict('sys_common_status')

const { exit, enter, isFullscreen: _isFullscreen } = useFullscreen()

const isFullscreen = ref<boolean>(false)
const fold = ref<boolean>(true)
const tableRef = ref<TableInstance>()
const list = ref<any>([])
const listLoading = ref<boolean>(true)

const total = ref<number>(0)
const selectRows = ref<any>([])
const checkList = ref<any>([])
const queryForm = reactive<any>({
  pageNum: 1,
  pageSize: 10,
  ipaddr: undefined,
  userName: undefined,
  status: undefined,
  dateRange: [],
  orderByColumn: undefined,
  isAsc: undefined,
})
const defaultSort = ref<any>({ prop: 'loginTime', order: 'descending' })
const selectName = ref<any>('')

const columns = ref<any>([
  { label: '访问编号', prop: 'infoId', minWidth: 120, checked: true },
  { label: '用户名称', prop: 'userName', minWidth: 160, sortable: 'custom', checked: true },
  { label: '地址', prop: 'ipaddr', minWidth: 160, checked: true },
  { label: '登录地点', prop: 'loginLocation', minWidth: 110, checked: true },
  { label: '操作系统', prop: 'os', minWidth: 130, checked: true },
  { label: '浏览器', prop: 'browser', minWidth: 120, checked: true },
  { label: '登录状态', prop: 'status', minWidth: 120, checked: true },
  { label: '描述', prop: 'msg', minWidth: 160, checked: true },
  { label: '访问时间', prop: 'loginTime', minWidth: 160, sortable: 'custom', checked: true },
])
const finallyColumns = computed(() => columns.value.filter((item: any) => checkList.value.includes(item.label)))

watch(
  _isFullscreen,
  () => {
    if (_isFullscreen.value) isFullscreen.value = true
    else isFullscreen.value = false
  },
  { immediate: true }
)

onActivated(() => {
  tableRef.value?.doLayout()
})

onBeforeMount(() => {
  columns.value.forEach((item: any) => {
    if (item.checked) checkList.value.push(item.label)
  })
  fetchData()
})

/** 点击全屏 */
const clickFullScreen = () => {
  isFullscreen.value = !isFullscreen.value
  isFullscreen.value ? enter() : exit()
}

/** 搜索条件折叠 */
const handleFold = () => {
  fold.value = !fold.value
}

/** 查询用户列表 */
const fetchData = async () => {
  listLoading.value = true
  // const pp = Object.assign({}, queryForm)
  const pp = Object.assign({}, proxy.addDateRange(queryForm, queryForm.dateRange))
  delete pp.dateRange
  const { rows, total: _total } = (await getList(pp)) as any
  list.value = rows
  total.value = _total
  listLoading.value = false
}

/** 搜索按钮操作 */
function handleQuery() {
  queryForm.pageNum = 1
  fetchData()
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm('queryRef')
  handleQuery()
}

const handleSizeChange = (value: number) => {
  queryForm.pageNum = 1
  queryForm.pageSize = value
  fetchData()
}

const handleCurrentChange = (value: number) => {
  queryForm.pageNum = value
  fetchData()
}

const setSelectRows = (value: any) => {
  selectRows.value = value
  selectName.value = value.map((item: any) => item.userName)
}

/** 排序触发事件 */
function handleSortChange(column: any) {
  queryForm.orderByColumn = column.prop
  queryForm.isAsc = column.order
  fetchData()
}

/** 清空按钮操作 */
function handleClean() {
  $baseConfirm('是否确认清空所有登录日志数据项?', null, async () => {
    await cleanLogininfor()
    $baseMessage('清空成功', 'success', 'hey')
    await fetchData()
  })
}

/** 解锁按钮操作 */
function handleUnlock() {
  const username = selectName.value

  $baseConfirm(`是否确认解锁用户"${username}"数据项?`, null, async () => {
    await unlockLogininfor(username)
    $baseMessage(`用户${username}解锁成功`, 'success', 'hey')
    await fetchData()
  })
}

/** 删除按钮操作 */
const handleDelete = (row: any = {}) => {
  if (row.infoId) {
    $baseConfirm(`您确定要删除访问编号为“${row.infoId}”的数据项吗`, null, async () => {
      const { msg }: any = await doDelete(row.infoId)
      $baseMessage(msg, 'success', 'hey')
      await fetchData()
    })
  } else {
    if (selectRows.value.length > 0) {
      const ids = selectRows.value.map((item: { infoId: any }) => item.infoId)
      $baseConfirm('您确定要删除选中项吗', null, async () => {
        const { msg }: any = await doDelete(ids)
        $baseMessage(msg, 'success', 'hey')
        await fetchData()
      })
    } else {
      $baseMessage('您未选中任何行', 'warning', 'hey')
    }
  }
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download(
    'monitor/logininfor/export',
    {
      ...queryForm,
    },
    `loginlog_${Date.now()}.xlsx`
  )
}
</script>
